<template>
	<div class="login-form">
		<h2>Click authentication</h2>
		<token-form kind="Click" @logged="handleLogin" />
	</div>
</template>

<script lang="ts" setup>
import { ElForm, ElFormItem, ElInput, ElButton } from "element-plus";
import { onMounted, ref } from "vue-demi";
import { Api, ApiResponse, ApiResponseError, Either, TE } from "../../lib/types";
import { A, AP, E, pipe, R, T } from "../../lib/utils";
import { apiResolveOrAlert, CacheKeys, getFromCache, redirect, saveToCache, uiSingleAlert } from "../ts/utils";
import TokenForm from "../components/TokenForm.vue";

const ifsToken = ref<string>('');
const rmToken = ref<string>('');
const clickToken = ref<string>('');

function handleLogin(success: boolean) {
	console.log('success', success);
	if (success) {
		redirect('/');
	}
}

// onMounted(() => {
// 	pipe(
// 		[CacheKeys.IFS_TOKEN, CacheKeys.RM_TOKEN, CacheKeys.CLICK_TOKEN],
// 		T.traverseArray(key => pipe(getFromCache<string>(key), T.map(x => x || ''))),
// 		T.map(([ifs, rm, click]) => {
// 			ifsToken.value = ifs;
// 			rmToken.value = rm;
// 			clickToken.value = click;
// 		})
// 	)()
// });

// function save() {
// 	pipe(
// 		{
// 			[CacheKeys.IFS_TOKEN]: ifsToken.value,
// 			[CacheKeys.RM_TOKEN]: rmToken.value,
// 			[CacheKeys.CLICK_TOKEN]: clickToken.value,
// 		},
// 		R.mapWithIndex((k, v) => saveToCache(k, v)),
// 		R.sequence(T.ApplicativePar),
// 		T.map(({
// 			[CacheKeys.IFS_TOKEN]: ifs,
// 			[CacheKeys.CLICK_TOKEN]: click,
// 			[CacheKeys.RM_TOKEN]: rm,
// 		}) => {
// 			const result = [];
// 			if (!ifs) result.push('IFS');
// 			if (!rm) result.push('RM');
// 			if (!click) result.push('CLICK');

// 			if (result.length) {
// 				uiSingleAlert(`Save failed these props: ${result.join(', ')}`);
// 			}
// 		})
// 	)();
// }
</script>

<style>
.login-form {
	width: 500px;
	margin: 0 auto;
}
</style>